/*xm2cheabop converter by irrlicht project, based on a routine by Shiru*/
/*This program is public domain*/

#define _CRT_SECURE_NO_WARNINGS
#include <stdlib.h>
#include <stdio.h>
#include <memory.h>
#include <unistd.h>
#include <sys/io.h>



unsigned char *xm;



int read_word(int off)
{
	return xm[off]+(xm[off+1]<<8);
}



int read_dword(int off)
{
	return xm[off]+(xm[off+1]<<8)+(xm[off+2]<<16)+(xm[off+3]<<24);
}



void cleanup(void)
{
	free(xm);
}



int main(int argc, char* argv[])
{
	FILE *file;
	int size;
	int order_len;
	int order_loop;
	int channels;
	int patterns;
	int tempo;
	int f,g,h,i,j,k,pp,patlen,slen;
	int tag,note,ins,drum;
	int row[4];
	int rem[4];
	const char name[10]="test.song";

	if(argc<2)
	{
		printf("Usage: ./xm2cheabop filename.xm\n");
		exit(0);
	}

	file=fopen(argv[1],"rb");

	if(!file)
	{
		printf("Error: Can't open file %s\n",argv[1]);
		exit(-1);
	}

	fseek(file,0,SEEK_END);
	size=ftell(file);
	fseek(file,0,SEEK_SET);

	xm=(unsigned char*)malloc(size);
	fread(xm,size,1,file);
	fclose(file);

	atexit(cleanup);

	if(memcmp(xm,"Extended Module: ",17))
	{
		printf("Error: Not XM module\n");
		exit(-1);
	}

	order_len=read_word(60+4);
	order_loop=read_word(60+6);
	channels=read_word(60+8);
	patterns=read_word(60+10);
	tempo=read_word(60+16);

	if(!order_len)
	{
		printf("Error: Module should have at least one order position\n");
		exit(-1);
	}

	if(channels<4)
	{
		printf("Error: Module should have 4 channels\n");
		exit(-1);
	}

	if(tempo<2)
	{
		printf("Error: Tempo must be 2 or higher\n");
		exit(-1);
	}



	file=fopen(name,"wt");

	tempo=tempo-1;

	fprintf(file,"%d\n",tempo);

	pp=60+20+256;
	pp=pp+read_dword(pp)+read_word(pp+7);

	patlen=read_word(pp+5);

	slen=patlen*order_len;

	fprintf(file,"%d\n",slen);

	rem[0]=40000;
	rem[1]=40000;

	for(f=0;f<2;f++)
	{

		for(i=0;i<patterns;i++)
		{

			pp=60+20+256;
			for(j=0;j<i;j++) pp=pp+read_dword(pp)+read_word(pp+7);

			patlen=read_word(pp+5);
			pp+=read_dword(pp);

			for(j=0;j<patlen;j++)
			{
				drum=0;

				for(k=0;k<channels;k++)
				{
					if(xm[pp]&0x80)
					{
						tag=xm[pp++];
						if(tag&0x01) note =xm[pp++]; else note =0;
						if(tag&0x02) ins  =xm[pp++]; else ins  =0;
					}
					else
					{
						note =xm[pp++];
						ins  =xm[pp++];
					}
					if(k<4)
					{
						row[k]=0;
						if(ins<2&&note>0&&note<=8*12+1) row[k]=note*2;
						if(note==97) row[k]=40000;

						g=0;

						if(row[f]>0&&row[f]<170)
						{
							for(h=1;h<10;h++)
							{
								row[f]=row[f]+24;

								if(row[f]>169)
								{
									g=h;
									h=11;
								}

							}


						}

						if(row[f]==170) row[f]=2094;
						if(row[f]==172) row[f]=2218;
						if(row[f]==174) row[f]=2350;
						if(row[f]==176) row[f]=2488;
						if(row[f]==178) row[f]=2636;
						if(row[f]==180) row[f]=2794;
						if(row[f]==182) row[f]=2960;
						if(row[f]==184) row[f]=3136;
						if(row[f]==186) row[f]=3322;
						if(row[f]==188) row[f]=3520;
						if(row[f]==190) row[f]=3730;
						if(row[f]==192) row[f]=3950;

						if(g>0&&row[f]>0&&row[f]<40000)
						{				
							for(h=0;h<g;h++)
							{
								row[f]=row[f]/2;
							}

						g=0;

						}

						if(row[f]==0) row[f]=rem[f];
					
					}

					rem[f]=row[f];

				}

				fprintf(file,"%d",row[f]);
				fprintf(file,"\n");
			}
		}

		fprintf(file,"\n");

	}


	for(i=0;i<patterns;i++)
	{

		pp=60+20+256;
		for(j=0;j<i;j++) pp=pp+read_dword(pp)+read_word(pp+7);

		patlen=read_word(pp+5);
		pp+=read_dword(pp);

		for(j=0;j<patlen;j++)
		{
			drum=0;

			for(k=0;k<channels;k++)
			{
				if(xm[pp]&0x80)
				{
					tag=xm[pp++];
					if(tag&0x01) note =xm[pp++]; else note =0;
					if(tag&0x02) ins  =xm[pp++]; else ins  =0;
				}
				else
				{
					note =xm[pp++];
					ins  =xm[pp++];
				}
				if(k<4)
				{
					row[k]=0;
					if(ins<2&&note>0&&note<=8*12+1) row[k]=note*2;
					if(note==97) row[k]=40000;
				}
				if(ins>=2) drum=1+(ins-2);
			}

			fprintf(file,"%d",drum);
			fprintf(file,"\n");
		}
		
	}

	fprintf(file,"\n");

	fclose(file);

	exit(0);
}
